<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:x="http://www.w3.org/TR/xpath">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4" xmlns:xalan="http://xml.apache.org/xslt"/>
    <xsl:strip-space elements="*"/>

    <xsl:template match="/x:AbsoluteLocationPath">
        <xsl:apply-templates select="x:NameStep[last()]"/>
    </xsl:template>
    <xsl:template match="/x:AbsoluteLocationPath/x:NameStep">
        <query select="{@localName}" from="{@prefix}">
            <xsl:choose>
                <xsl:when test="count(x:* | preceding-sibling::x:NameStep[1]) > 1">
                    <BooleanExpr symbol="AND">
                        <xsl:apply-templates select="x:*"/>
                        <xsl:if test="preceding-sibling::x:NameStep[1]">
                            <in column="{@pivot}">
                                <xsl:apply-templates select="preceding-sibling::x:NameStep[1]"/>
                            </in>
                        </xsl:if>
                    </BooleanExpr>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="x:*"/>
                    <xsl:if test="preceding-sibling::x:NameStep[1]">
                        <in column="{@pivot}">
                            <xsl:apply-templates select="preceding-sibling::x:NameStep[1]"/>
                        </in>
                    </xsl:if>
                </xsl:otherwise>
            </xsl:choose>
        </query>
    </xsl:template>

    <xsl:template match="x:RelativeLocationPath">
        <xsl:apply-templates select="x:NameStep[1]"/>
    </xsl:template>
    <xsl:template match="x:RelativeLocationPath/x:NameStep">
        <xsl:choose>
            <!-- first NameStep -->
            <xsl:when test="not(preceding-sibling::x:NameStep)">
                <xsl:choose>
                    <!-- same table -->
                    <xsl:when test="@prefix=ancestor::x:NameStep[1]/@prefix">
                        <xsl:apply-templates select="self::x:NameStep" mode="COMMON"/>
                    </xsl:when>
                    <!-- other table -->
                    <xsl:otherwise>
                        <in column="{ancestor::x:NameStep[1]/@pivot}">
                            <query select="{@pivot}" from="{@prefix}">
                                <xsl:apply-templates select="self::x:NameStep" mode="COMMON"/>
                            </query>
                        </in>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <!-- other NameStep -->
            <xsl:otherwise>
                <in column="{preceding-sibling::x:NameStep[1]/@localName}">
                    <query select="{@pivot}" from="{@prefix}">
                        <xsl:apply-templates select="self::x:NameStep" mode="COMMON"/>
                    </query>
                </in>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="x:RelativeLocationPath/x:NameStep" mode="COMMON">
        <xsl:choose>
            <xsl:when test="not(following-sibling::x:NameStep)">
                <Comparison symbol="{ancestor::x:Comparison/@symbol}">
                    <Column>
                        <xsl:value-of select="@localName"/>
                    </Column>
                    <xsl:for-each select="ancestor::x:Comparison/x:Literal | ancestor::x:Comparison/x:Number">
                        <xsl:element name="{local-name()}">
                            <xsl:value-of select="text()"/>
                        </xsl:element>
                    </xsl:for-each>
                </Comparison>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="following-sibling::x:NameStep[1]"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="x:AndExpr">
        <BooleanExpr symbol="AND">
            <xsl:apply-templates select="x:*"/>
        </BooleanExpr>
    </xsl:template>
    <xsl:template match="x:OrExpr">
        <BooleanExpr symbol="OR">
            <xsl:apply-templates select="x:*"/>
        </BooleanExpr>
    </xsl:template>
    <xsl:template match="x:NotExpr">
        <NotExpr>
            <xsl:apply-templates select="x:*"/>
        </NotExpr>
    </xsl:template>

    <!-- ignore other nodes -->
    <xsl:template match="x:*">
        <xsl:apply-templates select="x:*"/>
    </xsl:template>
</xsl:stylesheet>